import { Component, ElementRef, EventEmitter, HostBinding, OnInit, TemplateRef, ViewChild, ViewEncapsulation } from '@angular/core';
import { getCaretCoordinates } from './utils';
var MentionsListComponent = /** @class */ (function () {
    function MentionsListComponent() {
    }
    Object.defineProperty(MentionsListComponent.prototype, "selectedItem", {
        get: function () {
            return this.activeIndex >= 0 && this.items[this.activeIndex] !== undefined ? this.items[this.activeIndex] : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MentionsListComponent.prototype, "top", {
        get: function () {
            return this._top + this.adjustTop + 'px';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MentionsListComponent.prototype, "left", {
        get: function () {
            return this._left + 'px';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MentionsListComponent.prototype, "noItems", {
        get: function () {
            return !Array.isArray(this.items) || this.items.length === 0;
        },
        enumerable: true,
        configurable: true
    });
    MentionsListComponent.prototype.ngOnInit = function () {
        if (!this.itemTemplate) {
            this.itemTemplate = this.defaultItemTemplate;
        }
    };
    MentionsListComponent.prototype.onItemClick = function (event, activeIndex, item) {
        event.preventDefault();
        this.activeIndex = activeIndex;
        this.itemSelected.emit(item);
    };
    MentionsListComponent.prototype.selectFirstItem = function () {
        this.activeIndex = 0;
        this.resetScroll();
    };
    MentionsListComponent.prototype.selectPreviousItem = function () {
        if (this.activeIndex > 0) {
            this.activeIndex--;
        }
        this.scrollToActiveItem();
    };
    MentionsListComponent.prototype.selectNextItem = function () {
        if (this.activeIndex < this.items.length - 1) {
            this.activeIndex++;
            this.scrollToActiveItem();
        }
    };
    MentionsListComponent.prototype.selectLastItem = function () {
        this.activeIndex = this.items.length > 0 ? this.items.length - 1 : 0;
        this.scrollToActiveItem();
    };
    MentionsListComponent.prototype.position = function () {
        var element = this.textAreaElement;
        var coords = getCaretCoordinates(element, element.selectionStart);
        this._top = coords.top;
        this._left = coords.left + element.offsetLeft;
        this.list.nativeElement.scrollTop = 0;
    };
    MentionsListComponent.prototype.resetScroll = function () {
        this.list.nativeElement.scrollTop = 0;
    };
    MentionsListComponent.prototype.transformItem = function (item) {
        return this.displayTransform(item) || item;
    };
    Object.defineProperty(MentionsListComponent.prototype, "adjustTop", {
        get: function () {
            var adjust = 0;
            if (!this.dropUp) {
                var computed = getComputedStyle(this.textAreaElement);
                adjust = parseInt(computed.fontSize, 10) + this.textAreaElement.offsetTop;
            }
            return adjust;
        },
        enumerable: true,
        configurable: true
    });
    MentionsListComponent.prototype.scrollToActiveItem = function () {
        var element = this.list.nativeElement;
        if (this.activeIndex === 0) {
            element.scrollTop = 0;
        }
        else {
            var activeElement = element.querySelector('li.active');
            if (activeElement) {
                element.scrollTop = activeElement.offsetTop;
            }
        }
    };
    return MentionsListComponent;
}());
export { MentionsListComponent };
//# sourceMappingURL=mentions-list.component.js.map